#include "HelloInstantiator.h"

#include <pnp/basic_plan/basic_plan.h>
#include <pnp/pnp_plan.h>

#include "HelloAction.h"

using namespace PetriNetPlans;
using namespace std;

HelloInstantiator::HelloInstantiator(const std::string& plandir) :
			plandir(plandir), condition(), planLoader() {}


PnpExecutable* HelloInstantiator::createExecutable(const std::string& name) throw(std::runtime_error) {

	//check if it is an action
    if(name == "HelloWorld")
        return new HelloAction();

	
	//otherwise, check if it is a plan
    PnpPlan *plan = new PnpPlan(this, &condition,name);
    string pnml = plandir + name + ".pnml";
    try {
        planLoader.loadFromPNML ( pnml, plan );

    } catch ( const std::runtime_error& ) {
		
		//no file for that plan
        string errorString ( "No action nor plan with name: " );
        errorString+=name;
        throw std::runtime_error ( errorString );
    }

    return plan;
}
